﻿Imports MySql.Data.MySqlClient
Public Class frmDatos
    ' Ésta es una form "genérica", se adapta dependiendo lo que se quiera hacer.
    ' Tiene diferentes funciones para modificar / dar de alta.

    Dim llavePrimaria As String
    Dim Modificar As Boolean

    Public Sub New(ByVal llave As String, ByVal modifica As Boolean)
        ' Al iniciar la ventana se verifica si se va a modificar o agregar un usuario nuevo
        ' ^ con la variable modifica. 
        ' En caso de tener que modificar, obtiene los datos de la base de datos, y los deja en los
        ' textbox's correspondientes.

        InitializeComponent()
        Modificar = modifica
        If modifica Then
            llavePrimaria = llave
            Me.Text = "Modificar usuario"
            Dim cmd As MySqlCommand = New MySqlCommand(String.Format("SELECT * from `datos` where `ci`='{0}';", llavePrimaria), frmRegistro.conexion)
            Dim reader As MySqlDataReader = cmd.ExecuteReader()
            reader.Read()
            txtCI.Text = reader.GetString(0)
            reader.Read()
            txtNombre.Text = reader.GetString(1)
            reader.Read()
            txtApellido.Text = reader.GetString(2)
            reader.Read()
            txtTel.Text = reader.GetString(3)
            reader.Close()
        End If
    End Sub

    Private Function checkDatos() As Boolean
        ' Comprueba que realmente haya algo escrito en los campos de texto.
        If (String.IsNullOrWhiteSpace(txtCI.Text) Or
            String.IsNullOrWhiteSpace(txtNombre.Text) Or
            String.IsNullOrWhiteSpace(txtApellido.Text) Or
            String.IsNullOrWhiteSpace(txtTel.Text)) Then
            Return False
        Else
            Return True
        End If
    End Function

    Private Sub datosCambiados(sender As Object, e As EventArgs) Handles txtCI.TextChanged, txtNombre.TextChanged, txtApellido.TextChanged, txtTel.TextChanged
        ' Cuando se cambia el texto de los campos comprobamos si hay algo escrito en estos.
        ' Si es así, el botón Aceptar se activa, de lo contrario, se desactiva.
        
        btnAceptar.Enabled = checkDatos()
    End Sub

    Private Sub btnAceptar_Click(sender As Object, e As EventArgs) Handles btnAceptar.Click
        ' Al clickear al boton Aceptar, hay dos opciones.
        ' Que esté modificando, o agregando un nuevo usuario.
        ' Dependiendo de lo que se haga, se acomoda la sentencia.
        ' En caso de que la cédula ya esté en uso el usuario es notificado
        ' Tras guardar los cambios, la ventana desaparece, y los datos de la ventana principal 
        ' se actualizan.

        Dim cmd As New MySqlCommand
        cmd.Connection = frmRegistro.conexion

        If Not Modificar Then
            cmd.CommandText = String.Format("INSERT INTO `datos` VALUES ('{0}', '{1}', '{2}', '{3}', '{4}');", txtCI.Text, txtNombre.Text, txtApellido.Text, txtTel.Text, DateTime.Now.ToString("yyyy/MM/dd"))
        Else
            cmd.CommandText = String.Format("UPDATE `datos` SET `ci`='{0}', `nombre`='{1}', `apellido`='{2}', `telefono`='{3}' WHERE `ci`='{4}';", txtCI.Text, txtNombre.Text, txtApellido.Text, txtTel.Text, llavePrimaria)
        End If

        Try
            cmd.ExecuteNonQuery()
        Catch ex As Exception
            Console.Write(ex)
            If ex.ToString().Contains("Duplicate entry") Then
                MsgBox("Ya existe un usuario con esa CI.")
                Return
            End If
        End Try

        frmRegistro.actualizarDatos()
        Me.Dispose()
    End Sub

End Class