﻿Imports MySql.Data.MySqlClient
Public Class frmRegistro

    ' CREATE DATABASE `registro`;
    ' USE `registro`;
    ' CREATE TABLE IF NOT EXISTS `datos` (
    '  `ci` VARCHAR(8) NOT NULL,
    '  `nombre` VARCHAR(25) NOT NULL,
    '  `apellido` VARCHAR(25) NOT NULL,
    '  `telefono` VARCHAR(20) NOT NULL,
    '  `agregado` DATE NOT NULL,
    '  PRIMARY KEY (`ci`));

    Friend conexion As New MySqlConnection("server=localhost;uid=ignacio;password=ignacio;database=registro")
    Dim sentenciaBase As String
    Dim sentenciaBusqueda As String = "SELECT * FROM `datos` WHERE `ci` LIKE '%' OR `nombre` LIKE '%' OR `apellido` LIKE '%' OR `telefono` LIKE '%';"

    Private Sub frmRegistro_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' Conecta la base de datos y agrega las columnas a la lista
        ' luego actualiza los datos, y selecciona el botón "Cualquiera" por defecto.
        conexion.Open()
        listaUsuarios.View = View.Details
        listaUsuarios.FullRowSelect = True
        listaUsuarios.Columns.Add("Nombre", 120)
        listaUsuarios.Columns.Add("Apellido", 120)
        listaUsuarios.Columns.Add("Teléfono", 100)
        listaUsuarios.Columns.Add("CI", 100)
        actualizarDatos()
        radiobtn5.Checked = True
    End Sub

    Public Sub actualizarDatos()
        ' Limpio la lista de usuarios, y la actualizo con los datos de la db.
        Dim cmd As MySqlCommand = New MySqlCommand(sentenciaBusqueda, conexion)
        Dim reader As MySqlDataReader = cmd.ExecuteReader()
        Dim totalUsuarios As New Integer
        Dim miItem As New ListViewItem
        totalUsuarios = 0

        listaUsuarios.Items.Clear()

        While reader.Read()
            miItem = listaUsuarios.Items.Add(reader.GetString(1), 0)
            miItem.SubItems.Add(reader.GetString(2))
            miItem.SubItems.Add(reader.GetString(3))
            miItem.SubItems.Add(reader.GetString(0))
            miItem.SubItems.Add(reader.GetDateTime(4))
            totalUsuarios += 1
        End While

        lblUsuarios.Text = "No hay usuarios registrados."
        If totalUsuarios >= 1 Then
            lblUsuarios.Text = totalUsuarios & " usuario(s) registrado(s)"
        End If

        comprobarCheck()

        reader.Close()
    End Sub

    Private Sub btnBaja_Click(sender As Object, e As EventArgs) Handles btnBaja.Click
        ' Al clickear el botón de baja, le preguntamos al usuario si desea borrarlo.
        ' Muestra en pantalla (msgBox) los datos relevantes (nombre, apellido, ci) del usuario.
        ' De ser correcto, ejecutamos la sentencia para borrarlo

        Dim llavePrimaria, mensaje, nombre, apellido As String
        nombre = listaUsuarios.SelectedItems(0).SubItems(0).Text
        apellido = listaUsuarios.SelectedItems(0).SubItems(1).Text
        llavePrimaria = listaUsuarios.SelectedItems(0).SubItems(3).Text

        mensaje = String.Format("¿Está seguro de que quiere borrar a {0} {1}, cédula: {2}?", nombre, apellido, llavePrimaria)
        If MsgBox(mensaje, MsgBoxStyle.YesNo, "Dar de baja a un usuario") Then
            Dim cmd As MySqlCommand = New MySqlCommand(String.Format("DELETE FROM `datos` WHERE `ci`='{0}';", llavePrimaria), conexion)
            cmd.ExecuteNonQuery()
            actualizarDatos()
        End If
    End Sub

    Private Sub comprobarCheck()
        ' Comprueba si hay un item seleccionado en la lista de usuarios, 
        ' esto habilita/deshabilita las funciones de baja y modificación
        If (listaUsuarios.SelectedItems.Count > 0) Then
            btnBaja.Enabled = True
            btnModificar.Enabled = True
            lblAdded.Visible = True
            lblAdded.Text = "Agregado el: " & listaUsuarios.SelectedItems(0).SubItems(4).Text
        Else
            btnBaja.Enabled = False
            btnModificar.Enabled = False
            lblAdded.Visible = False
        End If
    End Sub

    Private Sub txtBusqueda_TextChanged(sender As Object, e As EventArgs) Handles txtBusqueda.TextChanged
        ' Cuando se cambia el texto del cuadro de busqueda, se arregla la sentencia de datos y se actualizan los datos.
        sentenciaBusqueda = String.Format(sentenciaBase, txtBusqueda.Text)
        actualizarDatos()
    End Sub

    Private Sub radioBtn_CheckedChanged(sender As Object, e As EventArgs) Handles radiobtn1.CheckedChanged, radiobtn2.CheckedChanged, radiobtn3.CheckedChanged, radiobtn4.CheckedChanged, radiobtn5.CheckedChanged
        ' Al cambiar de radioButton la sentencia de busqueda cambia.
        Select Case sender.Text
            Case "Cualquiera"
                sentenciaBase = "SELECT * FROM `datos` WHERE `ci` LIKE '{0}%' OR `nombre` LIKE '{0}%' OR `apellido` LIKE '{0}%' OR `telefono` LIKE '{0}%';"
            Case "Nombre"
                sentenciaBase = "SELECT * FROM `datos` WHERE `nombre` LIKE '{0}%';"
            Case "Apellido"
                sentenciaBase = "SELECT * FROM `datos` WHERE `apellido` LIKE '{0}%';"
            Case "CI"
                sentenciaBase = "SELECT * FROM `datos` WHERE `ci` LIKE '{0}%';"
            Case "Teléfono"
                sentenciaBase = "SELECT * FROM `datos` WHERE `telefono` LIKE '{0}%';"
        End Select

        sentenciaBusqueda = String.Format(sentenciaBase, txtBusqueda.Text)
        actualizarDatos()
    End Sub

    Private Sub btnModificar_Click(sender As Object, e As EventArgs) Handles btnModificar.Click
        ' Llama a la ventana para modificar los datos, le pasa la llave primaria + un True 
        ' para notificar que va a modificar.

        Dim frmDatos As New frmDatos(listaUsuarios.SelectedItems(0).SubItems(3).Text, True)
        frmDatos.ShowDialog(Me)
    End Sub

    Private Sub btnAlta_Click(sender As Object, e As EventArgs) Handles btnAlta.Click
        ' Llama a la ventana para agregar usuarios.

        Dim frmDatos As New frmDatos(Nothing, False)
        frmDatos.ShowDialog(Me)
    End Sub

    Private Sub seleccionLista_Cambiada(sender As Object, e As EventArgs) Handles listaUsuarios.SelectedIndexChanged
        ' Llama a comprobarCheck cuando se cambia la seleccion de la lista.
        comprobarCheck()
    End Sub

End Class
